<bugID>762579<Summary>Implement "SocialAPI service" (provider registry)</Summary><Description>At a high level, this component should be similar to the nsIBrowserSearchService. It will be a registry of "social providers", available to be used as part of the social functionality we'll be implementing.

See the following links for details of the current implementation in the social add-on:

https://github.com/mozilla/socialapi-dev/blob/develop/modules/registry.js
https://wiki.mozilla.org/Firefox_Social_Integration_Design_Spec#Social_Service_Registry

In a meeting we discussed moving away from SQLite in favor of either simple prefs, or a JSON file serialized to disk. To start, we'll just want the ability to have "built-in" providers, but we'll eventually be extending this to support installation of additional providers, so we should keep that in mind.

This might also involve incorporating parts of the existing "Social Service Provider" concept:
https://wiki.mozilla.org/Firefox_Social_Integration_Design_Spec#Social_Service_Provider
https://github.com/mozilla/socialapi-dev/blob/develop/modules/provider.js
This seems similar to e.g. nsISearchEngine, though the currently implementation has it tied somewhat closely to behaviors and UI, which might need to be re-worked.</Description></bugID>